/*
 * 쐬: 2005/01/01
 *
 * TODO ̐ꂽt@C̃ev[gύXɂ͎փWv:
 * EBhE - ݒ - Java - R[hEX^C - R[hEev[g
 */
package agent.copy;

import agentspace.Agent;
import agentspace.Context;
import agentspace.Duplicatable;
import agentspace.Preservable;
import agentspace.event.AgentEvent;

public class Test implements Agent, Preservable, Duplicatable {
	String state = "uninitialized"; 
	TestState t = null;
	public Test() {
		t = new TestState();
		t.setMessage(" in ");
		System.out.println("Test: an instance created. ["+state+"]"+t.getMessage());
		state = "initalized";
	}
		
	/* 
	 * @see agentspace.SerialiableAgent#create(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void create(AgentEvent evt, Context context) {
		System.out.println("Test: method create() called ["+state+"]"+t.getMessage());
		state = "created";
	}
	/* 
	 * @see agentspace.SerialiableAgent#destroy(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void destroy(AgentEvent evt, Context context) {
		System.out.println("Test: method destroy() called ["+state+"]"+t.getMessage());
		state = "destroyed";
	}
	/* 
	 * @see agentspace.SerialiableAgent#suspend(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void suspend(AgentEvent evt, Context context) {
		System.out.println("Test: method suspend() called ["+state+"]"+t.getMessage());
		state = "suspended";
	}

	/* 
	 * @see agentspace.SerialiableAgent#resume(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void resume(AgentEvent evt, Context context) {
		System.out.println("Test: method resume() called ["+state+"]"+t.getMessage());
		state = "resumed";
		context.store("newtest.jar");
	}

	/* ( Javadoc)
	 * @see agentspace.DuplicatableAgent#duplicate(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void duplicate(AgentEvent evt, Context ctxt) {
		System.out.println("Test: method duplicate() called ["+state+"]"+t.getMessage());
		state = "duplicating";
	}

	/* ( Javadoc)
	 * @see agentspace.DuplicatableAgent#parent(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void parent(AgentEvent evt, Context ctxt) {
		System.out.println("Test: method parent() called ["+state+"]"+t.getMessage());
		state = "parent";
	}

	/* ( Javadoc)
	 * @see agentspace.DuplicatableAgent#child(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void child(AgentEvent evt, Context ctxt) {
		System.out.println("Test: method child() called ["+state+"]"+t.getMessage());
		state = "child";
	}
}

class TestState implements java.io.Serializable {
	String msg;
	int counter = 0;
	TestState() {}
	public void setMessage(String msg) {
		this.msg = msg; 
	}
	public String getMessage() {
		counter = counter + 1;
		return msg + "("+counter+")";
	}
}
