package agent.chat;

import java.io.Serializable;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;

public class ChatSender implements Serializable {
	String hostname = null;
	int port = -1;

	public ChatSender(String hostname, int port) {
		this.hostname = hostname;
		this.port = port;
	}
	
	public int getPort() {
		return port;
	}
		
	public void send(char ch) {
		try{
			InetAddress addr = InetAddress.getByName(hostname); 
			DatagramSocket sock = new DatagramSocket();
			byte[] data = new byte[2];
			data[0] = (byte)ch;
			DatagramPacket packet = new DatagramPacket(data, data.length, addr, port);
			sock.send(packet);
//			System.out.println("ChatSender: sending ch = "+ch);
			sock.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
}
